VERSION 5.00
Begin VB.UserControl ctlMenu 
   BackColor       =   &H0000C000&
   ClientHeight    =   195
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   195
   KeyPreview      =   -1  'True
   ScaleHeight     =   195
   ScaleWidth      =   195
End
Attribute VB_Name = "ctlMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_lhWnd As Long
Private m_lMenuHeight As Long
Private m_lMenuWidth As Long
Private m_lBackColor As Long
Private m_lHilightColor As Long
Private m_lForeColor As Long
Private m_fTop As Single
Private m_fLeft As Single
Private WithEvents TrackMouse As clsTrackMouse
Attribute TrackMouse.VB_VarHelpID = -1
Private NEWMenuItems As Collection
Private mCurrentMenuItem As Long
Private mOldHilightIndex As Long
Private m_bmResizeReady As Boolean
Private m_bBottomEdgeLine As Boolean
Private m_bDrawControlBoxes As Boolean
Private m_bMenuCollapsed As Boolean
Private m_bDrawFormBoxes As Boolean
Private m_bSolidBackground As Boolean

Private WithEvents MyParent As Form
Attribute MyParent.VB_VarHelpID = -1

Private Const MenuTextBuffer As Long = 5

Private m_objAllMenuItems As MenuItem

Private Const BDR_RAISEDOUTER = &H1
Private Const BDR_SUNKENOUTER = &H2
Private Const BDR_RAISEDINNER = &H4
Private Const BDR_SUNKENINNER = &H8
Private Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Private Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
Private Const BF_LEFT = &H1
Private Const BF_TOP = &H2
Private Const BF_RIGHT = &H4
Private Const BF_BOTTOM = &H8
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
Private Declare Function DrawEdge Lib "user32" (ByVal hdc As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Boolean
Private Declare Function GetTextColor Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long

Private Const DST_PREFIXTEXT = &H2
Private Const DSS_NORMAL = &H0
Private Const DSS_DISABLED = &H20

Private Declare Function DrawStateText Lib "user32" Alias "DrawStateA" (ByVal hdc As Long, ByVal hBrush As Long, _
    ByVal lpDrawStateProc As Long, ByVal lParam As String, ByVal wParam As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal n3 As Long, _
    ByVal n4 As Long, ByVal un As Long) As Long

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private pPoint As POINTAPI

Private m_bDropped As Long

Public Event MenuClicked(xindex As Long, IsDropped As Boolean)
Attribute MenuClicked.VB_Description = "Event to identify when the manu has been clicked-  This one fires at an enormous rate and is not really usable for much..."
Public Event MenuKeyPressed(xindex As Long, KeyCode As Integer)
Attribute MenuKeyPressed.VB_Description = "Event raised when a menu accelerator key has been pressed"
Attribute MenuKeyPressed.VB_UserMemId = -604
Public Event ParentClosing()
Attribute ParentClosing.VB_Description = "Event raised when a menu's parent is being terminated"
Public Event SynchColors(BC As Long, HC As Long, FC As Long, HFC As Long)
Public Event ResetProperties(ctl As MenuItem)
Attribute ResetProperties.VB_Description = "Causes the menu and it's sub menus to re-evaluate their positions and sizes"

Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Private Declare Function ReleaseCapture Lib "user32" () As Long

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, _
    lParam As Any) As Long

    Private Const WM_LBUTTONUP = &H202
    Private Const WM_NCLBUTTONDOWN = &HA1
    Private Const HTCAPTION = 2
    
Dim fft As StdFont
Dim ffs As StdFont

Private Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long

Private Const OPAQUE = 2

Private DangerFlag As Boolean
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Const GWL_STYLE = (-16)
Private Const WS_CAPTION = &HC00000
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, _
    ByVal dwNewLong As Long) As Long
Private Const SWP_FRAMECHANGED = &H20
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOZORDER = &H4
Private Const SWP_NOSIZE = &H1
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, _
    ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

'------------------------------------------------------------------------------------------------------------------------------------
'------------------------------------------------------------------------------------------------------------------------------------

Public Sub InitMenu(Optional Index As Long = 1, Optional BakColor As Long = vbButtonFace, Optional HilgtColor As Long = vbHighlight, _
    Optional Fnt As StdFont = Nothing, Optional BottomEdge As Boolean = True, Optional ControlBoxes As Boolean = False, Optional _
    SolidBkground As Boolean)
Attribute InitMenu.VB_Description = "Must be called prior to doing anything else with the menu...  provides many default capable options."
  
    Static BeenHere As Boolean
    Dim cNC As New cNCMetrics
    
    If BeenHere = False Then
        BeenHere = True
    Else
        Exit Sub
    End If
        
    BottomEdgeLine = BottomEdge
    DrawControlBoxes = ControlBoxes
    Set MyParent = Extender.Parent

    cNC.GetMetrics
    
    If Fnt Is Nothing Then
        Set UserControl.Font = cNC.Font(UserControl.hdc, MenuFOnt)
    Else
        Set UserControl.Font = Fnt
    End If
    
    Set ffs = UserControl.Font
    
    MenuHeight = cNC.MenuHeight + 4
    MenuWidth = cNC.MenuWidth
    
    Extender.Top = ScaleX((Index - 1) * m_lMenuHeight, vbPixels, vbTwips)
    m_fTop = Extender.Top
    Extender.left = 0
    
    Bkcolor = BakColor
    
    HilightColor = HilgtColor
    mOldHilightIndex = -1
    
    SolidBackground = SolidBkground
    
    Set TrackMouse = New clsTrackMouse
    Set TrackMouse.TrackObject = Me
    
    ReDim MenuItems(-1 To -1) As MenuItem
  
    AutoRedraw = True
    
End Sub

Public Sub AddMenuItem(Caption$, Optional Enabled As Boolean = True, Optional Visible As Boolean = True, _
    Optional ForeColor As Long = vbMenuText, Optional HilghtTxtColor As Long = vbHighlightText, Optional _
    SolidBkground As Boolean = False)
Attribute AddMenuItem.VB_Description = "Adds items to the menu.  All parameters offer default values which will render a menu very similar to the Window Menu System."
    
    Dim Count As Long
    
    Dim m As MenuItem
    Set m = New MenuItem
    
    Count = NEWMenuItems.Count + 1
    
    With m
        .Caption = Caption
        .Enabled = Enabled
        .Visible = Visible
        .Index = Count
        .left = DetermineLeft(Count)
        .Right = .left + TextWidth(Caption) + (MenuTextBuffer * 2)
        .Width = .Right - .left
        .Top = 0
        .Bottom = m_lMenuHeight
        .Height = m_lMenuHeight
        .ForeColor = ForeColor
        .HilightTextColor = HilghtTxtColor
        If .Visible = False Then
            ReSetProps
        End If
    
    End With
    
    NEWMenuItems.Add m, m.Index & "e0"
    
    SolidBackground = SolidBkground
    ReDrawMenu NEWMenuItems.Count
    m_bmResizeReady = True
    
End Sub

Public Sub RemoveMenuItem(Index As Long)
Attribute RemoveMenuItem.VB_Description = "Removes a menu Item...  Current implementation only HIDES the item, does not actually remove it from the collection."
    NEWMenuItems(Index).Visible = False
    ReSetProps
    ReDrawMenu
End Sub

Public Sub SynchColorsNow(Optional BC As Long = vbButtonFace, Optional HC As Long = vbHighlight, Optional FC As Long = vbMenuText, _
    Optional HFC As Long = vbHighlightText)
Attribute SynchColorsNow.VB_Description = "Forces all menu items and sub menu items to have the same color scheme"
  
    Bkcolor = BC
    BackColor = BC
    
    HilightColor = HC
    Dim ctl As Variant
    
    For Each ctl In NEWMenuItems
        With ctl
            .HilightTextColor = HFC
            .ForeColor = FC
        End With
    Next
    If BC = vbButtonFace Then
        BC = vbWhite
    End If
    
    RaiseEvent SynchColors(BC, HC, FC, HFC)
    ReDrawMenu
    
End Sub

Private Sub ResizeMenu()
    If Not m_bmResizeReady Then Exit Sub
  
    Dim cNC As New cNCMetrics
    
    cNC.GetMetrics
        
    If MenuCollapsed Then
        Dim R1 As RECT
        Dim R2 As RECT
        R1 = CalculateControlRect(0)
        R2 = CalculateControlRect(3)
        If Not m_bDrawFormBoxes Then
            Extender.left = MyParent.ScaleWidth - ScaleX(R1.Right + 5, vbPixels, vbTwips)
            MenuWidth = MyParent.ScaleWidth - Extender.left
        Else
            Extender.left = MyParent.ScaleWidth - ScaleX(R2.Right - R1.left + 5, vbPixels, vbTwips)
            MenuWidth = MyParent.ScaleWidth - Extender.left
        End If
    Else
        MenuHeight = cNC.MenuHeight + 4
        MenuWidth = cNC.MenuWidth
        Extender.left = 0
    End If
    Cls
    ReDrawMenu
    
End Sub

Private Sub ReSetProps()
    
    Dim mi As MenuItem, Count&
    
    If NEWMenuItems.Count = 0 Then Exit Sub
    
    For Count = 1 To NEWMenuItems.Count
        Set mi = NEWMenuItems(Count)
        With mi
            If .Visible = False Then
                .left = DetermineLeft(Count)
                .Right = .left
                .Width = 0
            Else
                .left = DetermineLeft(Count)
                .Right = .left + TextWidth(.Caption) + (MenuTextBuffer * 2)
                .Width = .Right - .left
            End If
            RaiseEvent ResetProperties(mi)
        End With
    Next
    Cls
    ReDrawMenu
    
End Sub

Public Sub CloseThisMenu()
    ClickMenu mOldHilightIndex, False, 0, 0
    mOldHilightIndex = -1
    Dropped = -1
End Sub

'------------------------------------------------------------------------------------------------------------------------------------
'------------------------------------------------------------------------------------------------------------------------------------

Private Sub ReDrawMenu(Optional Index As Long = -1, Optional Hilight As Boolean = False)
    Dim Color As Long
    Dim Count As Long
  
    Color = -1
    
    If Index = -1 Then
        DrawCustomBackground SolidBackground
    End If
    
    If Hilight Then
        If mOldHilightIndex > -1 Then
            Cls
            ReDrawMenu
        End If
        DrawLine HilightColor, Index
        mOldHilightIndex = Index
        Color = NEWMenuItems(Index).HilightTextColor
    Else
        mOldHilightIndex = -1
    End If
    
    If m_bDrawControlBoxes Then
        DrawControlBoxChars
    End If
        
    If Not m_bMenuCollapsed Then
    
        If Index <> -1 Then
            With NEWMenuItems(Index)
                If mOldHilightIndex = Index Then
                    Color = NEWMenuItems(Index).HilightTextColor
                Else
                    Color = NEWMenuItems(Index).ForeColor
                End If
                If .Visible Then
                    DrawText hdc, .left, (.Top + (m_lMenuHeight - TextHeight("Wy")) / 2) - 2, .Caption, .Enabled, Color
                End If
            End With
        Else
            If NEWMenuItems.Count = 0 Then Exit Sub
            For Count = 1 To NEWMenuItems.Count
                If mOldHilightIndex = Count Then
                    Color = NEWMenuItems(Count).HilightTextColor
                Else
                    Color = NEWMenuItems(Count).ForeColor
                End If
                With NEWMenuItems(Count)
                    If .Visible Then
                        DrawText hdc, .left, (.Top + (m_lMenuHeight - TextHeight("Wy")) / 2) - 2, .Caption, .Enabled, Color
                    End If
                End With
            Next
        End If
    End If
    
    DrawControl
    
End Sub

Private Function DrawControlBoxChars(Optional Index As Long = -1, Optional ByVal Clr As Long = -1)
    
    Dim R As RECT
    Dim a As Long, b As Long, i As Long
    Dim fClr As Long
    
    If DrawControlBoxes = False Then Exit Function
    
    If Index = -1 Then
        a = 0: b = 3
    Else
        a = Index: b = Index
    End If
    
    If Clr = -1 Then
        Clr = HilightColor
    End If
        
    If Index = -1 Then
        fClr = NEWMenuItems(1).HilightTextColor
    Else
        fClr = NEWMenuItems(1).ForeColor
    End If
    
    For i = a To b
        
        R = CalculateControlRect(i)
        
        Set UserControl.Font = fft
        
        fft.Size = 13
            
        If m_bDrawFormBoxes Or i = 0 Then
            If Not (m_bDrawFormBoxes) And i = 0 Then
                R = CalculateControlRect(3)
                Set UserControl.Font = fft
                fft.Size = 13
            End If
            DrawText hdc, R.left, R.Top, "c", True, fClr 'vbWhite
            DrawText hdc, R.left, R.Top, "d", True, fClr 'vbWhite
        End If
        
        fft.Size = 11
        
        Select Case i
            Case 0
                If m_bMenuCollapsed Then
                    DrawText hdc, R.left + 1, R.Top + 1, "3", True, fClr, Clr
                Else
                    DrawText hdc, R.left + 1, R.Top + 1, "4", True, fClr, Clr 'MenuItems(0).ForeColor, Clr
                End If
            Case 1
                If m_bDrawFormBoxes Then
                    DrawText hdc, R.left + 1, R.Top + 1, "0", True, fClr, Clr
                End If
            Case 2
                If m_bDrawFormBoxes Then
                    If MyParent.WindowState = vbMaximized Then
                        DrawText hdc, R.left + 1, R.Top + 1, "2", True, fClr, Clr
                    Else
                        DrawText hdc, R.left + 1, R.Top + 1, "1", True, fClr, Clr
                    End If
                End If
            Case 3
                If m_bDrawFormBoxes Then
                    DrawText hdc, R.left + 1, R.Top + 1, "r", True, fClr, Clr
                End If
        End Select
        
    Next
    
    Set UserControl.Font = ffs
    
    'min,max,restore,close  '012r
    'down,up                'cd
    'Left and right arrow   '34
End Function

Private Sub DrawCustomBackground(Optional Solid As Boolean = False)
    Dim i As Single, Color As Long
    Dim w As Single, h As Single
    
    'TopToBottom
    w = ScaleX(Width, vbTwips, vbPixels)
    h = ScaleX(Height, vbTwips, vbPixels)
    If Not Solid Then
        For i = 0 To h
            Color = MakeDarker(BackColor, Int((i / h) * 55))
            UserControl.Line (0, i)-(w, i), Color
        Next i
    Else
        UserControl.Line (0, h)-(w, h), Color
    End If
    
End Sub

Private Sub DrawControl(Optional vntEdge)
    Dim R As RECT
    Dim intOffset%
    
    If BottomEdgeLine = False Then Exit Sub
    If Not (Extender.Parent) Is Nothing Then
  
        vntEdge = IIf(IsMissing(vntEdge), EDGE_RAISED, vntEdge)
        With UserControl
            R.left = -2
            R.Top = m_lMenuHeight - 2
            R.Right = Extender.Parent.ScaleWidth
            R.Bottom = R.Top + 2
            If vntEdge = EDGE_SUNKEN Then intOffset = 2
        End With
        DrawEdge hdc, R, CLng(vntEdge), BF_RECT
    End If
    
End Sub

'---------------------------------------------------------------------------------------------
Private Function DrawText(DrawOnDC As Long, x As Long, y As Long, hStr As String, tEnabled As Boolean, Clr As Long, _
    Optional bakclr As Long = -1) As Long

    Dim OT As Long
    
    If DrawOnDC = 0 Then Exit Function
    OT = GetTextColor(DrawOnDC)
    SetTextColor DrawOnDC, Clr
    If bakclr <> -1 Then
        Dim tmp As Long
        tmp = BackColor
        SetBkColor DrawOnDC, bakclr
        SetBkMode DrawOnDC, OPAQUE
    End If
    DrawText = DrawStateText(DrawOnDC, 0&, 0&, hStr, Len(hStr), x + 3, y, 0&, 0&, DST_PREFIXTEXT Or IIf(tEnabled = True, DSS_NORMAL, _
        DSS_DISABLED))
    SetTextColor DrawOnDC, OT
    If bakclr <> -1 Then
        BackColor = tmp
        SetBkMode DrawOnDC, 1&
    End If
End Function

Private Sub DrawLine(WhatColor&, Index As Long)
    With NEWMenuItems(Index)
        UserControl.Line (.left - 5, .Top + 1)-(.Right - 5, .Bottom - 4), WhatColor&, BF
    End With
End Sub

Private Function DetermineLeft(Index As Long)
    Select Case True
        Case Index = 1
            DetermineLeft = 5
        Case Else
            DetermineLeft = NEWMenuItems(Index - 1).Right + 1
    End Select
End Function

Private Function PinPointMouse(x As Long, y As Long) As Long
    Dim lpRect As RECT
    Dim CursorLeft As Long
    Dim CursorTop As Long
    Dim Count As Long
    
    GetWindowRect hwnd, lpRect
    CursorLeft = x - lpRect.left
    CursorTop = y - lpRect.Top
    
    PinPointMouse = -1
    
    If NEWMenuItems.Count = 0 Then Exit Function
    
    For Count = 1 To NEWMenuItems.Count
        With NEWMenuItems(Count)
            If CursorLeft > .left - 5 And CursorLeft < .Right - 5 Then
                If CursorTop < .Bottom + 1 Then
                    PinPointMouse = Count
                    Exit For
                End If
            End If
        End With
    Next
End Function

Private Function PinPointControlBoxes(x As Long, y As Long) As Long
    Dim lpRect As RECT
    Dim CursorLeft As Long
    Dim CursorTop As Long
    Dim Count As Long
    Dim R As RECT
    
    GetWindowRect hwnd, lpRect
    CursorLeft = x - lpRect.left
    CursorTop = y - lpRect.Top
    
    PinPointControlBoxes = -1
    
    If NEWMenuItems.Count = 0 Then Exit Function
    
    For Count = 0 To 3
        R = CalculateControlRect(Count)
        With R
            If CursorLeft > .left And CursorLeft < .Right Then
                If CursorTop < .Bottom And CursorTop > .Top Then
                    PinPointControlBoxes = Count
                    Exit For
                End If
            End If
        End With
    Next
End Function

Private Function CalculateControlRect(Index As Long) As RECT
    
    Dim R As RECT, x As Single, sw As Single
    
    If DrawControlBoxes = False Then Exit Function
    
    Set UserControl.Font = fft
    fft.Size = 13
    
    x = TextWidth("c")
    
    If m_bMenuCollapsed Then
        sw = 95
    Else
        sw = ScaleX(MyParent.ScaleWidth, vbTwips, vbPixels) + 10
    End If
    
    If m_bDrawFormBoxes = False And Index = 3 And m_bMenuCollapsed = True Then
        sw = (95 * (1 / 4)) + 9
    End If
            
    R.left = sw - (x * (4 - Index)) - (14 + ((3 - Index) * 4))
    R.Right = R.left + TextWidth("c")
    R.Top = 2
    R.Bottom = R.Top + TextHeight("c")
    
    CalculateControlRect = R
    
    Set UserControl.Font = ffs
    
End Function

Private Sub ClickMenu(Index As Long, DropIt As Boolean, KeyCode As Integer, Shift As Integer)
  
    If m_bMenuCollapsed Then Exit Sub
    If Index < 0 Then Exit Sub
    
    RaiseEvent MenuClicked(Index, DropIt)
    If DropIt = True Then
        Dropped = Index
        ReDrawMenu mOldHilightIndex, False
        mOldHilightIndex = Index
    Else
        Dropped = -1
        mOldHilightIndex = Index
    End If
    
    ReDrawMenu Index, True
    
    KeyCode = 0
    Shift = 0
  
End Sub

Private Function MakeLighter(ColorIn As Long, i As Long) As Long
      Dim R As Byte, g As Byte, b As Byte
      Dim R1 As Integer, B1 As Integer, G1 As Integer

   R = (ColorIn And 255) And 255
   g = (ColorIn \ 256) And 255
   b = (ColorIn \ 65536) And 255

   R1 = R + (i * 3)
   G1 = g + (i * 3)
   B1 = b + (i * 3)

   If R1 > 255 Then R1 = 255
   If G1 > 255 Then G1 = 255
   If B1 > 255 Then B1 = 255

   MakeLighter = RGB(R1, G1, B1)

End Function

Private Function MakeDarker(ColorIn As Long, i As Long) As Long
      Dim R As Byte, g As Byte, b As Byte
      Dim R1 As Integer, B1 As Integer, G1 As Integer

   R = (ColorIn And 255) And 255
   g = (ColorIn \ 256) And 255
   b = (ColorIn \ 65536) And 255

   R1 = R - (i * 3)
   G1 = g - (i * 3)
   B1 = b - (i * 3)

   If R1 < 0 Then R1 = 0
   If G1 < 0 Then G1 = 0
   If B1 < 0 Then B1 = 0

   MakeDarker = RGB(R1, G1, B1)

End Function

Private Sub KeyHandler(KeyCode As Integer, Shift As Integer)
    
    Dim Temp As Long, xVal As Long
    
    Dim AltKey As Boolean
    Dim WhichMenu As Long
    
    If m_bMenuCollapsed Then Exit Sub
    
    AltKey = (Shift And vbAltMask) > 0
    
    If AltKey Then
        WhichMenu = IsValidAccelerator(KeyCode)
        If WhichMenu > -1 Then
            Select Case True
                Case (Dropped > -1)
                    If WhichMenu = Dropped Then
                        ClickMenu WhichMenu, False, KeyCode, Shift
                    Else
                        ClickMenu Dropped, False, KeyCode, Shift
                        ClickMenu WhichMenu, True, KeyCode, Shift
                    End If
                Case Else
                    ClickMenu WhichMenu, True, KeyCode, Shift
            End Select
        End If
        
        If KeyCode = vbKeyQ Then
            If Dropped > -1 Then
            With MenuItemsCol(Dropped)
                SynchColorsNow BackColor, .HilightTextColor, .ForeColor
            End With
            End If
        End If
    Else
        If Dropped > -1 Or mOldHilightIndex > -1 Then
            Temp = Dropped: If Temp = -1 Then Temp = mOldHilightIndex

            Select Case KeyCode
                Case vbKeyLeft
                    xVal = -1
                Case vbKeyRight
                    xVal = 1
            End Select

            If xVal <> 0 Then
                Temp = Temp + xVal
                If Temp > -1 And Temp <= NEWMenuItems.Count Then
                    ClickMenu Temp - xVal, False, KeyCode, Shift
                    ClickMenu Temp, True, KeyCode, Shift
                End If
            End If

            'Up/Down Keys
            Select Case KeyCode
                Case vbKeyUp, vbKeyDown, vbKeyReturn

                    If KeyCode > 0 Then
      
                        If Dropped = -1 Then
                            Dropped = Temp
                            ClickMenu Temp, True, KeyCode, Shift
                        End If
      
                        RaiseEvent MenuKeyPressed(Temp, KeyCode)
      
                        If Dropped = -1 Then
                            Cls
                            ReDrawMenu
                            KeyCode = 0
                        End If
  
                    End If
            End Select
        End If
    End If
    
End Sub

Private Function IsValidAccelerator(KeyCode As Integer) As Long
    'return the index if valid else -1
    Dim i%, x%
    
    If m_bMenuCollapsed Then Exit Function
    
    IsValidAccelerator = -1
    If NEWMenuItems.Count = 0 Then Exit Function
    
    For i = 1 To NEWMenuItems.Count
        x = InStr(1, NEWMenuItems(i).Caption, "&")
        If x > 0 Then
            If Asc(UCase(Mid$(NEWMenuItems(i).Caption, x + 1, 1))) = KeyCode Then
                IsValidAccelerator = i
                Exit For
            End If
        End If
    Next
End Function

'Private Function WhatModeIsIt() As String
'    Static BeenHere As String
'    If BeenHere = "" Then
'        BeenHere = "Not OK"
'        If Ambient.UserMode = True Then
'            If Ambient.UIDead = False Then
'                BeenHere = "OK"
'            End If
'        End If
'    End If
'    WhatModeIsIt = BeenHere
'End Function

'------------------------------------------------------------------------------------------------------------------------------------
'------------------------------------------------------------------------------------------------------------------------------------


Private Sub MyParent_KeyDown(KeyCode As Integer, Shift As Integer)
    KeyHandler KeyCode, Shift
End Sub

Private Sub MyParent_Resize()
    ResizeMenu
End Sub

Private Sub MyParent_Unload(Cancel As Integer)
    RaiseEvent ParentClosing
End Sub

Private Sub TrackMouse_MouseOut()
    Cls
    mCurrentMenuItem = -1
    mOldHilightIndex = -1
    ReDrawMenu
End Sub

Private Sub TrackMouse_MouseOver(ByVal x As Long, ByVal y As Long)
    Dim Index As Long
    
TopSpot:
    Index = PinPointMouse(x, y)
    
    If Index > -1 And m_bMenuCollapsed = False Then
        If mCurrentMenuItem <> Index Then
            ReDrawMenu Index, True
            mCurrentMenuItem = Index
        End If
        If NEWMenuItems(Index).Enabled = True Then
            If Dropped > -1 Then
                If Dropped <> Index Then
                    Dropped = Index
                    RaiseEvent MenuClicked(Index, True)
                End If
            End If
        End If
    Else
    
        'are we over a controlbox?
        Dim xx As Long
        xx = PinPointControlBoxes(x, y)
        If xx > -1 Then
            If m_bDrawFormBoxes = False And m_bMenuCollapsed = False Then
                If xx = 3 Then
                    xx = 0
                Else
                    GoTo BottomSpot:
                End If
            End If
            ReDrawMenu
            DrawControlBoxChars xx, BackColor
        Else
            Cls
            ReDrawMenu
            mOldHilightIndex = -1
            mCurrentMenuItem = -1
        End If
    End If
BottomSpot:
End Sub

'------------------------------------------------------------------------------------------------------------------------------------
'------------------------------------------------------------------------------------------------------------------------------------

Private Sub UserControl_Initialize()
    ScaleMode = vbPixels
    Dropped = -1
    Set NEWMenuItems = New Collection
    Set fft = New StdFont
    fft.Name = "Marlett"
    fft.Size = 12
    m_bDrawFormBoxes = True
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    If Not m_bMenuCollapsed Then
        KeyHandler KeyCode, Shift
    End If
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim xx As Long
    Dim Index As Long
    Extender.ZOrder 0
    
    Index = -1
    
    If m_bMenuCollapsed = False Then
        Dim X1 As Long, Y1 As Long
        GetCursorPos pPoint
        X1 = pPoint.x
        Y1 = pPoint.y
        Index = PinPointMouse(X1, Y1)
        
        If Index > -1 Then
            If NEWMenuItems(Index).Enabled = False Then
                Exit Sub
            Else
                Dropped = Index
                RaiseEvent MenuClicked(Index, True)
                Exit Sub
            End If
        End If
        
        If Dropped = -1 Then
            Dropped = Index
        Else
            RaiseEvent MenuClicked(Dropped, False)
            Dropped = -1
        End If
    End If
    
    If Index = -1 Then
        Extender.ZOrder 0
        
        xx = PinPointControlBoxes(X1, Y1)
        
        Select Case xx
            Case 0, 1, 2, 3
            Case Else
                'we must be moving the form
                If MyParent.WindowState <> vbMaximized Then
                    Dim mpos As POINTAPI
                    Dim p As ConvertPOINTAPI
                    Dim ret As Integer
                    
                    Call GetCursorPos(mpos)
                    LSet p = mpos
                    ret = SendMessage(hwnd, WM_LBUTTONUP, 0, p.xy)
                    If Not DangerFlag Then
                      ReleaseCapture
                      SendMessage MyParent.hwnd, WM_NCLBUTTONDOWN, HTCAPTION, 0&
                    End If
                End If
        End Select
    End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim xx As Long
    Extender.ZOrder 0
    
    Dim X1 As Long, Y1 As Long
    GetCursorPos pPoint
    X1 = pPoint.x
    Y1 = pPoint.y
    
    xx = PinPointControlBoxes(X1, Y1)
    
    Select Case xx
        Case 0
            If m_bDrawFormBoxes Or (m_bMenuCollapsed And Not m_bDrawFormBoxes) Then
                MenuCollapsed = Not (MenuCollapsed)
                ResizeMenu
                ReDrawMenu
            End If
        Case 1
            If m_bDrawFormBoxes Then
                MyParent.WindowState = vbMinimized
            End If
        Case 2
            If m_bDrawFormBoxes Then
                Select Case MyParent.WindowState
                    Case vbMaximized
                        MyParent.WindowState = vbNormal
                    Case Else
                        MyParent.WindowState = vbMaximized
                        MenuCollapsed = MenuCollapsed
                End Select
            End If
        Case 3
            If m_bDrawFormBoxes Then
                DangerFlag = True
                MyParent.Hide
                Unload MyParent
            Else
                MenuCollapsed = Not (MenuCollapsed)
                ResizeMenu
                ReDrawMenu
            End If
        Case Else
        
    End Select
    
End Sub

Private Sub UserControl_Paint()
    'On Error GoTo OutSpot
    
    If Ambient.UserMode = False Then
        DrawText hdc, 0, 0, "TopLevel", True, vbBlack
    End If
        
OutSpot:
End Sub

Private Sub UserControl_Terminate()
    Dim mi As Variant
    For Each mi In NEWMenuItems
        Set mi = Nothing
    Next
    Set NEWMenuItems = Nothing
    Set m_objAllMenuItems = Nothing
    Set MyParent = Nothing
    Set fft = Nothing
    Set ffs = Nothing
End Sub

'------------------------------------------------------------------------------------------------------------------------------------
'------------------------------------------------------------------------------------------------------------------------------------

Private Function Style(Optional ByVal NewBits As Long = 0) As Long
   If NewBits Then
      Call SetWindowLong(MyParent.hwnd, GWL_STYLE, NewBits)
   End If
   If Not (MyParent Is Nothing) Then
    Style = GetWindowLong(MyParent.hwnd, GWL_STYLE)
   End If
End Function

Private Function FlipBit(ByVal Bit As Long, ByVal Value As Boolean) As Boolean
   Dim nStyle As Long
   nStyle = GetWindowLong(MyParent.hwnd, GWL_STYLE)
   If Value Then
      nStyle = nStyle Or Bit
   Else
      nStyle = nStyle And Not Bit
   End If
   Call SetWindowLong(MyParent.hwnd, GWL_STYLE, nStyle)
   Call Redraw
   FlipBit = (nStyle = GetWindowLong(MyParent.hwnd, GWL_STYLE))
End Function

Private Sub Redraw()
   Const swpFlags As Long = SWP_FRAMECHANGED Or SWP_NOMOVE Or SWP_NOZORDER Or SWP_NOSIZE
   SetWindowPos MyParent.hwnd, 0, 0, 0, 0, 0, swpFlags
End Sub

'------------------------------------------------------------------------------------------------------------------------------------
'------------------------------------------------------------------------------------------------------------------------------------

Public Property Get MenuItemsCol(Index As Long) As MenuItem
Attribute MenuItemsCol.VB_Description = "MenuItem Collection - items exposed as type MenuItem useful for modifying individual menu items after they are added in..."
Attribute MenuItemsCol.VB_ProcData.VB_Invoke_Property = ";Misc"
Attribute MenuItemsCol.VB_MemberFlags = "400"
    Set MenuItemsCol = NEWMenuItems(Index)
End Property

Public Property Get Font() As StdFont
Attribute Font.VB_Description = "Just your normal average font property..."
Attribute Font.VB_ProcData.VB_Invoke_Property = "StandardFont;Font"
Attribute Font.VB_MemberFlags = "400"
    Set Font = UserControl.Font
End Property

Public Property Let Bkcolor(ByVal lBackColor As Long)
    If (lBackColor And &H80000000) Then
        m_lBackColor = GetSysColor(lBackColor And &HFFFFFF)
    Else
        m_lBackColor = lBackColor
    End If
    UserControl.BackColor = m_lBackColor
End Property

Public Property Get Bkcolor() As Long
Attribute Bkcolor.VB_Description = "BackColor of the control.  Accepts vb color constants or a long [RGB(,,] value."
Attribute Bkcolor.VB_ProcData.VB_Invoke_Property = "StandardColor;Appearance"
Attribute Bkcolor.VB_UserMemId = -501
Attribute Bkcolor.VB_MemberFlags = "400"
    Bkcolor = m_lBackColor
End Property

Public Property Let Dropped(ByVal bDropped As Long)
    m_bDropped = bDropped
End Property

Public Property Get Dropped() As Long
Attribute Dropped.VB_Description = "Holds the index of the Currently dropped down menu item."
Attribute Dropped.VB_ProcData.VB_Invoke_Property = ";Data"
Attribute Dropped.VB_MemberFlags = "400"
    Dropped = m_bDropped
End Property

Public Property Let ForeColor(ByVal lForeColor As Long)
    m_lForeColor = lForeColor
End Property

Public Property Get ForeColor() As Long
Attribute ForeColor.VB_Description = "color of normal menu item text."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = "StandardColor;Appearance"
Attribute ForeColor.VB_UserMemId = -513
Attribute ForeColor.VB_MemberFlags = "400"
    ForeColor = m_lForeColor
End Property

Public Property Let HilightColor(ByVal lHilightColor As Long)
    If (lHilightColor And &H80000000) Then
        m_lHilightColor = GetSysColor(lHilightColor And &HFFFFFF)
    Else
        m_lHilightColor = lHilightColor
    End If
End Property

Public Property Get HilightColor() As Long
Attribute HilightColor.VB_Description = "Color of the hilight bar"
Attribute HilightColor.VB_ProcData.VB_Invoke_Property = "StandardColor;Appearance"
Attribute HilightColor.VB_UserMemId = -503
Attribute HilightColor.VB_MemberFlags = "400"
    HilightColor = m_lHilightColor
End Property

Private Property Let hwnd(ByVal lhWnd As Long)
    m_lhWnd = lhWnd
End Property

Public Property Get hwnd() As Long
Attribute hwnd.VB_Description = "expose the hWnd for internal subclassing as well as external..."
Attribute hwnd.VB_ProcData.VB_Invoke_Property = ";Misc"
Attribute hwnd.VB_UserMemId = -515
Attribute hwnd.VB_MemberFlags = "400"
    hwnd = UserControl.hwnd
End Property

Private Property Let left(ByVal fLeft As Single)
    m_fLeft = fLeft
End Property

Public Property Get left() As Single
Attribute left.VB_Description = "Read only- left edge of the control"
Attribute left.VB_ProcData.VB_Invoke_Property = ";Position"
Attribute left.VB_MemberFlags = "400"
    left = m_fLeft
End Property

Private Property Let Top(ByVal fTop As Single)
    m_fTop = fTop
End Property

Public Property Get Top() As Single
Attribute Top.VB_Description = "Identifies the Top of the contrl in Pixels."
Attribute Top.VB_ProcData.VB_Invoke_Property = ";Position"
Attribute Top.VB_MemberFlags = "400"
    Top = ScaleY(m_fTop, vbTwips, vbPixels)
End Property

Private Property Get ResizeReady() As Boolean
    ResizeReady = m_bmResizeReady
End Property

Private Property Let MenuHeight(ByVal lMenuHeight As Long)
    m_lMenuHeight = lMenuHeight
    Extender.Height = ScaleY(lMenuHeight, vbPixels, vbTwips)
End Property

Public Property Get MenuHeight() As Long
Attribute MenuHeight.VB_Description = "The height of the menu in pixels"
Attribute MenuHeight.VB_ProcData.VB_Invoke_Property = ";Position"
Attribute MenuHeight.VB_MemberFlags = "400"
    MenuHeight = m_lMenuHeight
End Property

Private Property Let MenuWidth(ByVal lMenuWidth As Long)
    m_lMenuWidth = lMenuWidth
    Extender.Width = Extender.Parent.Width
End Property

Public Property Get MenuWidth() As Long
Attribute MenuWidth.VB_Description = "Width of the menu depends on whether or not it's collapsed"
Attribute MenuWidth.VB_ProcData.VB_Invoke_Property = ";Position"
Attribute MenuWidth.VB_MemberFlags = "400"
    MenuWidth = m_lMenuWidth
End Property

Public Property Let BottomEdgeLine(ByVal bBottomEdgeLine As Boolean)
    m_bBottomEdgeLine = bBottomEdgeLine
End Property

Public Property Get BottomEdgeLine() As Boolean
Attribute BottomEdgeLine.VB_Description = "Shows or hides the 3D line along the bottom of the menu."
Attribute BottomEdgeLine.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute BottomEdgeLine.VB_MemberFlags = "400"
    BottomEdgeLine = m_bBottomEdgeLine
End Property

Public Property Let DrawControlBoxes(ByVal bDrawControlBoxes As Boolean)
    m_bDrawControlBoxes = bDrawControlBoxes
End Property

Public Property Get DrawControlBoxes() As Boolean
Attribute DrawControlBoxes.VB_Description = "Determines whether or not to draw the min, max, close and collapse buttons."
Attribute DrawControlBoxes.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute DrawControlBoxes.VB_MemberFlags = "400"
    DrawControlBoxes = m_bDrawControlBoxes
End Property

Public Property Let MenuCollapsed(ByVal bMenuCollapsed As Boolean)
    m_bMenuCollapsed = bMenuCollapsed
End Property

Public Property Get MenuCollapsed() As Boolean
Attribute MenuCollapsed.VB_Description = "Identifies when the user has clicked the collapse button."
Attribute MenuCollapsed.VB_ProcData.VB_Invoke_Property = ";Position"
Attribute MenuCollapsed.VB_UserMemId = -500
Attribute MenuCollapsed.VB_MemberFlags = "400"
    MenuCollapsed = m_bMenuCollapsed
End Property

Public Property Let Titlebar(ByVal Value As Boolean)
   Call FlipBit(WS_CAPTION, Value)
End Property

Public Property Get Titlebar() As Boolean
Attribute Titlebar.VB_Description = "If true then the parent forms caption is used for the Task bar, but the caption bar is not shown on the applicaion itself."
Attribute Titlebar.VB_ProcData.VB_Invoke_Property = ";Text"
Attribute Titlebar.VB_UserMemId = -518
Attribute Titlebar.VB_MemberFlags = "400"
   Titlebar = CBool(Style And WS_CAPTION)
End Property

Public Property Get DrawFormBoxes() As Boolean
Attribute DrawFormBoxes.VB_Description = "If DrawControlBoxes is True then this will show or hide the min/max/close buttons"
Attribute DrawFormBoxes.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute DrawFormBoxes.VB_MemberFlags = "400"
    DrawFormBoxes = m_bDrawFormBoxes
End Property

Public Property Let DrawFormBoxes(ByVal bDrawFormBoxes As Boolean)
    m_bDrawFormBoxes = bDrawFormBoxes
End Property

Public Property Get SolidBackground() As Boolean
Attribute SolidBackground.VB_Description = "Use a dithered or solid background color..."
Attribute SolidBackground.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute SolidBackground.VB_UserMemId = -502
Attribute SolidBackground.VB_MemberFlags = "400"
    SolidBackground = m_bSolidBackground
End Property
Public Property Let SolidBackground(ByVal v As Boolean)
    m_bSolidBackground = v
End Property
