VERSION 5.00
Begin VB.UserControl ctlSubMenu 
   Appearance      =   0  'Flat
   BackColor       =   &H0000FF00&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   195
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   195
   KeyPreview      =   -1  'True
   ScaleHeight     =   195
   ScaleWidth      =   195
End
Attribute VB_Name = "ctlSubMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private MenuItems() As MenuItem
Private Const VMenuTextBuffer As Long = 3
Private Const HMenuTextBuffer As Long = 6
Private Const mSepHeight As Long = 5

Private m_lhWnd As Long
Private WithEvents m_ctlMenuParent As ctlMenu
Attribute m_ctlMenuParent.VB_VarHelpID = -1
Private m_lMenuTextHeight As Long
Private m_lMenuTextWidth As Long
Private mOldHilightIndex As Long
Private m_lHilightColor As Long
Private m_lMenuHeight As Long
Private m_lMenuWidth As Long
Private m_lCurrentMenuItem As Long
Private m_bChildShowing As Boolean
Private m_bSolidBackground As Boolean
Private m_bHasChild As Boolean

Dim ft1 As New StdFont
Dim ft2 As StdFont
    
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Private Declare Function GetTextColor Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Const DST_PREFIXTEXT = &H2
Private Const DSS_NORMAL = &H0
Private Const DSS_DISABLED = &H20

Private Declare Function DrawStateText Lib "user32" Alias "DrawStateA" (ByVal hdc As Long, ByVal hBrush As Long, _
    ByVal lpDrawStateProc As Long, ByVal lParam As String, ByVal wParam As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal n3 As Long, _
    ByVal n4 As Long, ByVal un As Long) As Long

Private WithEvents TrackMouse As clsTrackMouse
Attribute TrackMouse.VB_VarHelpID = -1

Public Event SubItemClicked(Parent As Long, SubIndex As Long)
Public Event SubItemHover(Parent As Long, SubIndex As Long)
Public Event ParentClosing()
Public Event SynchColors(BC As Long, HC As Long, FC As Long, HFC As Long)
Public Event OptionButtonsClicked(Parent As Long, SubIndex As Long)

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private pPoint As POINTAPI

Private Const BDR_RAISEDOUTER = &H1
Private Const BDR_SUNKENOUTER = &H2
Private Const BDR_RAISEDINNER = &H4
Private Const BDR_SUNKENINNER = &H8
Private Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Private Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
Private Const BF_LEFT = &H1
Private Const BF_TOP = &H2
Private Const BF_RIGHT = &H4
Private Const BF_BOTTOM = &H8
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
Private Declare Function DrawEdge Lib "user32" (ByVal hdc As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Boolean

Public Sub AddSubMenuItem(Caption$, MyParent As MenuItem, Optional Seperator As Boolean = False, Optional Enabled As Boolean = True, _
    Optional Visible As Boolean = True, Optional xForeColor As Long = -1, Optional xHilghtTxtColor As Long = -1, _
    Optional xBkcolor As Long = vbWhite, Optional eStyle As enm_MenuStyles = Menu_Normal, Optional bChecked As Boolean = False, _
    Optional SolidBkground As Boolean = False)
    
    Dim Count As Long
    
    If MenuParent Is Nothing Then
        Err.Raise vbObject + mnuerror_MustSetParentFirst, "AddSubMenuItem", "You must set the Menu Parent to a valid ctlMenu control first"
        Exit Sub
    End If
    If MyParent Is Nothing Then
        Err.Raise vbObject + mnuerror_MustSetParentFirst, "AddSubMenuItem", "You must supply the Menu Parent"
        Exit Sub
    End If
    
    Count = UBound(MenuItems) + 1
    
    If Count < 1 Then
        ReDim MenuItems(0 To Count) As MenuItem
    Else
        ReDim Preserve MenuItems(0 To Count) As MenuItem
    End If
    
    Set MenuItems(Count) = New MenuItem
    
    Extender.Visible = False
    
    With MenuItems(Count)
        .Caption = "  " & Caption & "  "
        .Enabled = Enabled
        .Visible = Visible
        .Index = Count
        .ParentIndex = MyParent.Index
        .left = 0
        .Right = MaxMenuTextWidth
        .Width = .Right - .left
        If Count = 0 Then
            .Top = 0
        Else
            .Top = MenuItems(Count - 1).Bottom + 1 + (VMenuTextBuffer)
        End If
        .Seperator = Seperator
        If Seperator Then
            .Bottom = .Top + (TextHeight(.Caption)) + mSepHeight
        Else
            .Bottom = .Top + (TextHeight(.Caption))
        End If
        .Height = .Bottom - .Top
        If xForeColor <> -1 Then
            .ForeColor = xForeColor
        Else
            .ForeColor = MyParent.ForeColor
        End If
        If xHilghtTxtColor <> -1 Then
            .HilightTextColor = xHilghtTxtColor
        Else
            .HilightTextColor = MyParent.HilightTextColor
        End If
        
        .Style = eStyle
        .Checked = bChecked
        
        SubMenuHeight = .Bottom + (VMenuTextBuffer)
        SubMenuWidth = MaxMenuTextWidth + (HMenuTextBuffer * 2)
  
    End With
        
    SolidBackground = SolidBkground
    
    HilightColor = MenuParent.HilightColor
    
    If xBkcolor <> vbWhite Then
        If xBkcolor = -1 Then
            BackColor = MenuParent.Bkcolor
        Else
            BackColor = xBkcolor
        End If
    Else
        BackColor = vbWhite
    End If
    
    Extender.left = ScaleX(MyParent.left - (HMenuTextBuffer / 2) - 1, vbPixels, vbTwips)
    Extender.Top = ScaleY((MenuParent.Top + MenuParent.MenuHeight) - 1, vbPixels, vbTwips)
    Extender.ZOrder 0
    
    ReSetProps
    
    ReDrawMenu Count
    
End Sub

Private Sub ReDrawMenu(Optional Index As Long = -1, Optional Hilight As Boolean = False)
    Dim Color As Long
    
    'walk the parent and close all other submenus
  
    Color = -1
    If Hilight Then
        If mOldHilightIndex > -1 Then
            Cls
            ReDrawMenu
        End If
        DrawLine HilightColor, Index
        mOldHilightIndex = Index
        Color = MenuItems(Index).HilightTextColor
    Else
        mOldHilightIndex = -1
    End If
    
    If Index = -1 Then
        If Not SolidBackground Then
            DrawCustomBackground
        Else
            Dim R As RECT
            R.left = 0
            R.Top = 0
            R.Right = ScaleWidth
            R.Bottom = ScaleHeight
            DrawBorder Color, R
        End If
    End If
    DrawMenuItem Index, Color
End Sub

Public Sub DrawMenuItem(Index As Long, Color As Long)
    Dim Count As Long
    Dim ca As Long, cb As Long
    
    If Index = -1 Then
        ca = LBound(MenuItems): cb = UBound(MenuItems)
    Else
        ca = Index: cb = Index
    End If
    
    Set ft2 = Font
    
    ft1.Name = "Wingdings"
    ft1.Size = Font.Size + 1
    
    For Count = ca To cb
        With MenuItems(Count)
            If mOldHilightIndex = Count Then
                Color = .HilightTextColor
            Else
                Color = .ForeColor
            End If

            If .Visible Then
                
                If .Seperator Then
                    DrawText hdc, .left + HMenuTextBuffer + 3, .Top + (1 * VMenuTextBuffer), .Caption, .Enabled, Color
                    DrawControl 0, .Bottom - 1
                Else
                    DrawText hdc, .left + HMenuTextBuffer + 3, .Top + (0.7 * VMenuTextBuffer), .Caption, .Enabled, Color
                End If
                
                If .ShowMENUARROWRIGHT Then
                    DrawArrow .left, .Top, .Enabled, Color
                End If
                
                Select Case .Style
                    Case enm_MenuStyles.Menu_CheckBox
                        Set Font = ft1
                        '
                        If .Checked Then
                            DrawText hdc, .left + 2, .Top + (1.2 * VMenuTextBuffer), "", .Enabled, Color
                        Else
                            DrawText hdc, .left + 2, .Top + (1.2 * VMenuTextBuffer), "o", .Enabled, Color
                        End If
                        Set Font = ft2

                    Case enm_MenuStyles.Menu_Option
                        Set Font = ft1
                        If .Checked Then
                            DrawText hdc, .left + 1, .Top + (1 * VMenuTextBuffer), "", .Enabled, Color
                        Else
                            DrawText hdc, .left + 1, .Top + (1 * VMenuTextBuffer), "", .Enabled, Color
                        End If
                        Set Font = ft2
                End Select
                
            End If
        End With
    Next
    
End Sub


Private Sub DrawControl(x As Long, y As Long, Optional vntEdge)
    Dim R As RECT
    Dim intOffset%
    vntEdge = IIf(IsMissing(vntEdge), EDGE_RAISED, vntEdge)
    With UserControl
        R.left = -2
        R.Top = y
        R.Right = ScaleX(Extender.Width, vbTwips, vbPixels) + 2
        R.Bottom = y + 2
        If vntEdge = EDGE_SUNKEN Then intOffset = 2
    End With
    DrawEdge hdc, R, CLng(vntEdge), BF_RECT
End Sub

Private Sub DrawLine(ByVal WhatColor As Long, Index As Long)
    With MenuItems(Index)
        ReSetProps
        If Not .Seperator Then
            UserControl.Line (.left + 2, .Top + 1)-(.Right + mSepHeight + 2, .Bottom - 1), WhatColor&, BF
        Else
            UserControl.Line (.left + 2, .Top + 2)-(.Right + mSepHeight + 2, .Bottom - 4), WhatColor&, BF
        End If
    End With
End Sub

Private Sub DrawBorder(ByVal WhatColor As Long, R As RECT)
    UserControl.DrawWidth = 3
    UserControl.Line (R.left, R.Top)-(R.Right, R.Bottom), WhatColor&, B
    UserControl.DrawWidth = 1
End Sub
Private Function DrawText(DrawOnDC As Long, x As Long, y As Long, hStr As String, tEnabled As Boolean, ByVal Clr As Long) As Long

    Dim OT As Long
    
    If DrawOnDC = 0 Then Exit Function
    OT = GetTextColor(DrawOnDC)
    SetTextColor DrawOnDC, Clr
    If tEnabled = False Then
        DrawText = DrawStateText(DrawOnDC, 0&, 0&, hStr, Len(hStr), x, y - 1.5, 0&, 0&, DST_PREFIXTEXT Or DSS_DISABLED)
    Else
        DrawText = DrawStateText(DrawOnDC, 0&, 0&, hStr, Len(hStr), x, y, 0&, 0&, DST_PREFIXTEXT Or DSS_NORMAL)
    End If
    SetTextColor DrawOnDC, OT

End Function

Public Sub DrawArrow(x As Long, y As Long, tEnabled As Boolean, ByVal Color As Long)
    Dim R As RECT
 
    R.Right = UserControl.ScaleWidth
    R.left = R.Right - TextWidth(">")
    
    R.Top = (y + (VMenuTextBuffer / 2)) + 4
    R.Bottom = ((y + TextHeight("Wy")) - (VMenuTextBuffer / 2))
    Dim i As Long
    If Not tEnabled Then Color = &HB0B0B0
    For i = R.left To R.Right
        If (R.Top + (i - R.left)) - (R.Bottom - (i - R.left)) < 0 Then
            UserControl.Line (i, R.Top + (i - R.left))-(i, R.Bottom - (i - R.left)), Color
        End If
    Next i
End Sub

Private Function DetermineTop(Index As Long)
    Select Case True
        Case Index = 0
            DetermineTop = (VMenuTextBuffer / 2) - 1
        Case Else
            DetermineTop = MenuItems(Index - 1).Bottom + 1
    End Select
End Function

'Private Sub CloseOtherSubMenus()
'    Dim ctl As Control
'    For Each ctl In Extender.Parent.Controls
'        If TypeOf ctl Is ctlSubMenu Then
'            If Not (ctl Is Me) Then
'                ctl.CloseThisMenu
'            End If
'        End If
'    Next
'End Sub
Private Sub DrawCustomBackground()
    Dim i As Single, Color As Long
    Dim w As Single, h As Single
    
    'left to right
    w = ScaleX(Width, vbTwips, vbPixels)
    h = ScaleX(Height, vbTwips, vbPixels)
    For i = 0 To w
        Color = MakeDarker(BackColor, Int((i / w) * 55))
        UserControl.Line (i, 0)-(i, h), Color
    Next i
    Dim R As RECT
    R.left = 0
    R.Right = w - 1
    R.Top = 0
    R.Bottom = h - 1

    DrawEdge hdc, R, EDGE_RAISED, BF_RECT
    
    'TopToBottom
    'w = ScaleX(Width, vbTwips, vbPixels)
    'h = ScaleX(Height, vbTwips, vbPixels)
    'For i = 0 To h
    '    color = MakeLighter(BackColor, Int((i / h) * 75))
    '    UserControl.Line (0, i)-(w, i), color
    'Next i
End Sub

Public Sub SynchColorsNow(Optional BC As Long = vbButtonFace, Optional HC As Long = vbHighlight, Optional FC As Long = vbMenuText, _
    Optional HFC As Long = vbHighlightText)
  
    BackColor = BC
    HilightColor = HC
    Dim ctl As Variant
    
    For Each ctl In MenuItems
        With ctl
            .HilightTextColor = HFC
            .ForeColor = FC
        End With
    Next
    SolidBackground = m_ctlMenuParent.SolidBackground
    ReDrawMenu
    
End Sub

Private Function MaxMenuTextWidth() As Long
    
    Dim Count&, TempMax&
    TempMax = -1
    For Count = LBound(MenuItems) To UBound(MenuItems)
        If TextWidth(MenuItems(Count).Caption) > TempMax Then
            TempMax = TextWidth(MenuItems(Count).Caption)
        End If
    Next
    MaxMenuTextWidth = TempMax

End Function

Private Function MakeDarker(ColorIn As Long, i As Long) As Long
      Dim R As Byte, g As Byte, b As Byte
      Dim R1 As Integer, B1 As Integer, G1 As Integer

   R = (ColorIn And 255) And 255
   g = (ColorIn \ 256) And 255
   b = (ColorIn \ 65536) And 255

   R1 = R - (i * 3)
   G1 = g - (i * 3)
   B1 = b - (i * 3)

   If R1 < 0 Then R1 = 0
   If G1 < 0 Then G1 = 0
   If B1 < 0 Then B1 = 0

   MakeDarker = RGB(R1, G1, B1)

End Function

Private Function MakeLighter(ColorIn As Long, i As Long) As Long
      Dim R As Byte, g As Byte, b As Byte
      Dim R1 As Integer, B1 As Integer, G1 As Integer

   R = (ColorIn And 255) And 255
   g = (ColorIn \ 256) And 255
   b = (ColorIn \ 65536) And 255

   R1 = R + (i * 3)
   G1 = g + (i * 3)
   B1 = b + (i * 3)

   If R1 > 255 Then R1 = 255
   If G1 > 255 Then G1 = 255
   If B1 > 255 Then B1 = 255

   MakeLighter = RGB(R1, G1, B1)

End Function

Public Property Get MenuItemsCol(Index As Long) As MenuItem
    Set MenuItemsCol = MenuItems(Index)
End Property

Public Sub CloseThisMenu()
    Cls
    CurrentMenuItem = -1
    ReDrawMenu
    Extender.Visible = False
    MenuParent.CloseThisMenu
End Sub

Private Function PinPointMouse(x As Long, y As Long, Optional UseWindowRect As Boolean = True) As Long
    Dim lpRect As RECT
    Dim CursorLeft As Long
    Dim CursorTop As Long
    Dim Count As Long
    
    If UseWindowRect Then
        GetWindowRect hwnd, lpRect
        CursorLeft = x - lpRect.left
        CursorTop = y - lpRect.Top
    Else
        'GetWindowRect hwnd, lpRect
        CursorLeft = x '- lpRect.Left
        CursorTop = y '- lpRect.Top
    End If
    
    PinPointMouse = -1
    
    For Count = LBound(MenuItems) To UBound(MenuItems)
        With MenuItems(Count)
            'If CursorTop > .Top - (VMenuTextBuffer / 2) And CursorTop < .Bottom Then
            If CursorTop > .Top And CursorTop < .Bottom Then
                If UseWindowRect = False Then
                    If (CursorLeft - Extender.left) <= .Right And (CursorLeft - Extender.left) >= .left Then
                        PinPointMouse = Count
                        Exit For
  
                    End If
                Else
                    PinPointMouse = Count
                    Exit For
                End If
            End If
        End With
    Next
End Function

Public Sub CheckMousePosition()
    Dim X1 As Long, Y1 As Long, Index As Long
    
    Dim cNC As New cNCMetrics
    cNC.GetMetrics
    
    GetCursorPos pPoint
    X1 = (pPoint.x - ScaleX(UserControl.Parent.left, vbTwips, vbPixels)) - cNC.BorderWidth
    Y1 = (pPoint.y - ScaleY(UserControl.Parent.Top, vbTwips, vbPixels) - cNC.CaptionHeight) - MenuParent.MenuHeight
  
    Set cNC = Nothing
    
    Index = PinPointMouse(X1, Y1, False)
    If (Index = -1) Or (Index <> -1 And HasChild = False) Then
        CloseThisMenu
    End If
End Sub

Private Sub GoToMenuItem(Index As Long)

    If Index > -1 And Index <= UBound(MenuItems) Then
        ReDrawMenu Index, True
        CurrentMenuItem = Index
    End If
End Sub

Public Sub ReSetProps()
    
    Dim mi As MenuItem, Count&
    
    For Count = LBound(MenuItems) To UBound(MenuItems)
        Set mi = MenuItems(Count)
        With mi
            If .Visible = False Then
                .Top = DetermineTop(Count)
                .Bottom = .Top
                .Height = 0
                .Width = MaxMenuTextWidth
                .Right = .left + .Width
            Else
                .Top = DetermineTop(Count)
                .Bottom = .Top + TextHeight(.Caption) + VMenuTextBuffer
                If .Seperator Then
                    .Bottom = .Bottom + mSepHeight
                End If
                .Height = .Bottom - .Top
                .Width = MaxMenuTextWidth
                .Right = .left + .Width
            End If
        End With
    Next
    Cls
    ReDrawMenu

   On Error GoTo 0
   Exit Sub

ReSetProps_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure ReSetProps of User Control ctlSubMenu"
    
End Sub

Private Sub m_ctlMenuParent_MenuClicked(xindex As Long, IsDropped As Boolean)
    Extender.ZOrder 0
    If MenuItems(0).ParentIndex = xindex Then
        Extender.Visible = IsDropped
        GoToMenuItem 0
    Else
        Extender.Visible = False
    End If
End Sub

Private Sub m_ctlMenuParent_MenuKeyPressed(xindex As Long, KeyCode As Integer)
    If MenuItems(0).ParentIndex = xindex Then
        Select Case KeyCode
            Case vbKeyUp
                GoToMenuItem CurrentMenuItem - 1
            Case vbKeyDown
                GoToMenuItem CurrentMenuItem + 1
            Case vbKeyReturn
                If CurrentMenuItem <> -1 Then
                    'On Error Resume Next
                    If MenuItems(CurrentMenuItem).Enabled Then
                        If Not Extender Is Nothing Then
                            Extender.Visible = False
                        End If
                        If Not (MenuParent Is Nothing) Then
                            MenuParent.Dropped = -1
                        End If
                        RaiseEvent SubItemClicked(MenuItems(0).ParentIndex, CurrentMenuItem)
                    End If
                End If
        End Select
    End If

End Sub

Private Sub m_ctlMenuParent_ParentClosing()
    RaiseEvent ParentClosing
    Set m_ctlMenuParent = Nothing
End Sub


Private Sub m_ctlMenuParent_ResetProperties(ctl As MenuItem)
    If MenuItems(0).ParentIndex = ctl.Index Then
        ReSetProps
        Extender.left = ScaleX(ctl.left - (HMenuTextBuffer / 2) - 1, vbPixels, vbTwips)
        Extender.Top = ScaleY((MenuParent.Top + MenuParent.MenuHeight) - 1, vbPixels, vbTwips)
    End If
End Sub

Private Sub m_ctlMenuParent_SynchColors(BC As Long, HC As Long, FC As Long, HFC As Long)
    SynchColorsNow BC, HC, FC, HFC
    RaiseEvent SynchColors(BC, HC, FC, HFC)
End Sub

Private Sub UserControl_Initialize()
    ReDim MenuItems(-1 To -1) As MenuItem
    ScaleMode = vbPixels
    AutoRedraw = True
    DrawText hdc, 0, 0, "SubMenu", True, vbBlack
OutSpot:
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim Index As Long
    
    Dim X1 As Long, Y1 As Long
    GetCursorPos pPoint
    X1 = pPoint.x
    Y1 = pPoint.y
    Index = PinPointMouse(X1, Y1)
    
    If Index <> -1 Then
        With MenuItems(Index)
            If .Enabled Then
                'On Error Resume Next
                Extender.Visible = False
                MenuParent.Dropped = -1
                RaiseEvent SubItemClicked(MenuItems(0).ParentIndex, Index)
                If .Style <> Menu_Normal Then
                    .Checked = Not (.Checked)
                    If .Style = Menu_Option Then
                        OptionButtonClick Index
                        RaiseEvent OptionButtonsClicked(MenuItems(0).ParentIndex, Index)
                    End If
                End If
            End If
        End With
    End If

End Sub

Private Sub UserControl_Terminate()
    Dim mi As Variant
    For Each mi In MenuItems
        Set mi = Nothing
    Next
    Erase MenuItems
    Set m_ctlMenuParent = Nothing

End Sub

Private Sub TrackMouse_MouseOut()
    If m_bHasChild Then
        If Not ChildShowing Then
            CloseThisMenu
        End If
    Else
        CloseThisMenu
    End If
End Sub

Private Sub TrackMouse_MouseOver(ByVal x As Long, ByVal y As Long)
    Dim Index As Long
    
    Index = PinPointMouse(x, y)
    If Index > -1 Then
        If CurrentMenuItem <> Index Then
            ReDrawMenu Index, True
            CurrentMenuItem = Index
        Else
            CurrentMenuItem = Index
        End If
    Else
        Cls
        CurrentMenuItem = -1
        ReDrawMenu
    End If
  
End Sub

Public Sub Refresh()
    UserControl.Refresh
End Sub

Public Property Get ChildShowing() As Boolean
    ChildShowing = m_bChildShowing
End Property

Public Property Let ChildShowing(ByVal bChildShowing As Boolean)
    m_bChildShowing = bChildShowing
End Property

Public Property Get CurrentMenuItem() As Long
    CurrentMenuItem = m_lCurrentMenuItem
End Property

Public Property Let CurrentMenuItem(ByVal lCurrentMenuItem As Long)
    m_lCurrentMenuItem = lCurrentMenuItem
    ChildShowing = (lCurrentMenuItem <> -1) And (m_bHasChild = True)
    RaiseEvent SubItemHover(CurrentMenuItem, -1)
End Property

Public Property Get Font() As StdFont
    Set Font = UserControl.Font
End Property

Public Property Set Font(xfnt As StdFont)
    Set UserControl.Font = xfnt
End Property

Public Property Get HasChild() As Boolean
    HasChild = m_bHasChild
End Property

Public Property Let HasChild(ByVal bHasChild As Boolean)
    m_bHasChild = bHasChild
End Property

Public Property Get hdc() As Long
    hdc = UserControl.hdc
End Property

Public Property Get HilightColor() As Long
    HilightColor = m_lHilightColor
End Property

Public Property Let HilightColor(ByVal lHilightColor As Long)
    If (lHilightColor And &H80000000) Then
        m_lHilightColor = GetSysColor(lHilightColor And &HFFFFFF)
    Else
        m_lHilightColor = lHilightColor
    End If
End Property

Public Property Get hwnd() As Long
    hwnd = UserControl.hwnd
End Property

Private Property Let hwnd(ByVal lhWnd As Long)
    m_lhWnd = lhWnd
End Property

Public Property Get left() As Long
    left = ScaleY(Extender.left, vbTwips, vbPixels)
End Property

Public Property Get Top() As Long
    Top = ScaleY(Extender.Top, vbTwips, vbPixels)
End Property

Public Property Get MenuParent() As ctlMenu
    Set MenuParent = m_ctlMenuParent
End Property

Public Property Set MenuParent(ctlMenuParent As ctlMenu)
    If m_ctlMenuParent Is Nothing Then
        Set m_ctlMenuParent = ctlMenuParent
        Set UserControl.Font = ctlMenuParent.Font
        Set TrackMouse = New clsTrackMouse
        Set TrackMouse.TrackObject = Me
    Else
        Err.Raise ErrorEnum.mnuerror_MustSetParentFirst, "SetMenuParent", "Parent Already Set"
    End If
End Property

Public Property Get MenuTextHeight() As Long
    MenuTextHeight = m_lMenuTextHeight
End Property

Private Property Let MenuTextHeight(ByVal lMenuTextHeight As Long)
    m_lMenuTextHeight = lMenuTextHeight
End Property

Public Property Get MenuTextWidth() As Long
    MenuTextWidth = m_lMenuTextWidth
End Property

Private Property Let MenuTextWidth(ByVal lMenuTextWidth As Long)
    m_lMenuTextWidth = lMenuTextWidth
End Property

Public Property Get SubMenuHeight() As Long
    SubMenuHeight = m_lMenuHeight
End Property

Private Property Let SubMenuHeight(ByVal lMenuHeight As Long)
    m_lMenuHeight = lMenuHeight
    Extender.Height = ScaleY(lMenuHeight, vbPixels, vbTwips)
End Property

Public Property Get SubMenuWidth() As Long
    SubMenuWidth = m_lMenuWidth
End Property

Private Property Let SubMenuWidth(ByVal lMenuWidth As Long)
    m_lMenuWidth = lMenuWidth
    Extender.Width = ScaleX(lMenuWidth, vbPixels, vbTwips)
End Property

Private Sub OptionButtonClick(ByVal Index As Long)
    Dim i As Long
    
    For i = LBound(MenuItems) To UBound(MenuItems)
        With MenuItems(i)
            If .Style = Menu_Option Then
                .Checked = (Index = i)
            End If
        End With
    Next i
End Sub

Public Property Get SolidBackground() As Boolean
    SolidBackground = m_bSolidBackground
End Property
Public Property Let SolidBackground(ByVal bSolidBackground As Boolean)
    m_bSolidBackground = bSolidBackground
End Property

