VERSION 5.00
Begin VB.UserControl ctlSubMenuChild 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H00C0FFC0&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   195
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   195
   ScaleHeight     =   195
   ScaleWidth      =   195
End
Attribute VB_Name = "ctlSubMenuChild"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private MenuItems() As MenuItem
Private Const VMenuTextBuffer As Long = 3
Private Const HMenuTextBuffer As Long = 6
Private Const mSepHeight As Long = 5

Private m_lhWnd As Long
Private WithEvents m_ctlSubMenuParent As ctlSubMenu
Attribute m_ctlSubMenuParent.VB_VarHelpID = -1
Private mOldHilightIndex As Long
Private m_lHilightColor As Long
Private m_lMenuHeight As Long
Private m_lMenuWidth As Long
Private m_lCurrentMenuItem As Long
Private m_bSolidBackground As Boolean

Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Private Declare Function GetTextColor Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Const DST_PREFIXTEXT = &H2
Private Const DSS_NORMAL = &H0
Private Const DSS_DISABLED = &H20

Private Declare Function DrawStateText Lib "user32" Alias "DrawStateA" (ByVal hdc As Long, ByVal hBrush As Long, _
    ByVal lpDrawStateProc As Long, ByVal lParam As String, ByVal wParam As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal n3 As Long, _
    ByVal n4 As Long, ByVal un As Long) As Long

Private WithEvents TrackMouse As clsTrackMouse
Attribute TrackMouse.VB_VarHelpID = -1

Public Event SubItemChildClicked(Parent As Long, SubIndex As Long)

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private pPoint As POINTAPI

Private Const BDR_RAISEDOUTER = &H1
Private Const BDR_SUNKENOUTER = &H2
Private Const BDR_RAISEDINNER = &H4
Private Const BDR_SUNKENINNER = &H8
Private Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Private Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
Private Const BF_LEFT = &H1
Private Const BF_TOP = &H2
Private Const BF_RIGHT = &H4
Private Const BF_BOTTOM = &H8
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
Private Declare Function DrawEdge Lib "user32" (ByVal hdc As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Boolean

Public Sub AddSubMenuItem(Caption$, MyParent As MenuItem, Optional Seperator As Boolean = False, Optional Enabled As Boolean = True, _
    Optional Visible As Boolean = True, Optional ForeColor As Long = -1, Optional HilghtTxtColor As Long = -1, _
    Optional Bkcolor As Long = vbWhite, Optional eStyle As enm_MenuStyles = Menu_Normal, Optional bChecked As Boolean = False, _
    Optional SolidBkground As Boolean = False)
    
    Dim Count As Long
    
    If SubMenuParent Is Nothing Then
        Err.Raise vbObject + mnuerror_MustSetParentFirst, "AddSubMenuItem", "You must set the Menu Parent to a valid ctlMenu control first"
        Exit Sub
    End If
    
    Count = UBound(MenuItems) + 1
    
    If Count < 1 Then
        ReDim MenuItems(0 To Count) As MenuItem
    Else
        ReDim Preserve MenuItems(0 To Count) As MenuItem
    End If
    
    Set MenuItems(Count) = New MenuItem
    
    Extender.Visible = False
    
    With MenuItems(Count)
        .Caption = Caption
        .Enabled = Enabled
        .Visible = Visible
        .Index = Count
        .ParentIndex = MyParent.Index
        .left = HMenuTextBuffer
        .Right = MaxMenuTextWidth + .left
        .Width = .Right - .left + HMenuTextBuffer
        If Count = 0 Then
            .Top = 0
        Else
            .Top = MenuItems(Count - 1).Bottom + 1 + (VMenuTextBuffer)
        End If
        .Seperator = Seperator
        If Seperator Then
            .Bottom = .Top + (TextHeight(.Caption)) + mSepHeight
        Else
            .Bottom = .Top + (TextHeight(.Caption))
        End If
        .Height = .Bottom - .Top
        If ForeColor <> -1 Then
            .ForeColor = ForeColor
        Else
            .ForeColor = MyParent.ForeColor
        End If
        If HilghtTxtColor <> -1 Then
            .HilightTextColor = HilghtTxtColor
        Else
            .HilightTextColor = MyParent.HilightTextColor
        End If
        
        .Style = eStyle
        .Checked = bChecked
        
        SolidBackground = SolidBkground
        
        SubMenuHeight = .Bottom + (VMenuTextBuffer)
        SubMenuWidth = MaxMenuTextWidth + (HMenuTextBuffer * 3)
  
    End With
    
    HilightColor = SubMenuParent.HilightColor
    
    If Bkcolor <> vbWhite Then
        If Bkcolor = -1 Then
            BackColor = SubMenuParent.MenuParent.Bkcolor
        Else
            BackColor = Bkcolor
        End If
    Else
        BackColor = vbWhite
    End If
    
    Extender.left = ScaleX((MyParent.left + MyParent.Width) + (HMenuTextBuffer) + 1, vbPixels, vbTwips)
    Extender.Top = ScaleY(m_ctlSubMenuParent.Top + MyParent.Top + 1, vbPixels, vbTwips)
    Extender.ZOrder 0
    
    ReSetProps
    
    ReDrawMenu Count
    
End Sub

Private Sub ReDrawMenu(Optional Index As Long = -1, Optional Hilight As Boolean = False)
    Dim Color As Long
    Dim Count As Long
  
    Color = -1
    If Hilight Then
        If mOldHilightIndex > -1 Then
            Cls
            ReDrawMenu
        End If
        DrawLine HilightColor, Index
        mOldHilightIndex = Index
        Color = MenuItems(Index).HilightTextColor
    Else
        mOldHilightIndex = -1
    End If
    
    If Index = -1 Then
        If Not SolidBackground Then
            DrawCustomBackground
        End If
    End If
    
    If Index <> -1 Then
        With MenuItems(Index)
            If mOldHilightIndex = Index Then
                Color = MenuItems(Index).HilightTextColor
            Else
                Color = MenuItems(Index).ForeColor
            End If
            If .Visible Then
                DrawText hdc, .left + (0.5 * HMenuTextBuffer), .Top + (0.5 * VMenuTextBuffer), .Caption, .Enabled, Color
            End If
            If .Seperator Then
                If Hilight Then
                    DrawControl 0, .Bottom - (mSepHeight - 2)
                Else
                    DrawControl 0, .Bottom
                End If
            End If
        End With
    Else
        For Count = LBound(MenuItems) To UBound(MenuItems)
            If mOldHilightIndex = Count Then
                Color = MenuItems(Count).HilightTextColor
            Else
                Color = MenuItems(Count).ForeColor
            End If
            With MenuItems(Count)
                If .Visible Then
                    DrawText hdc, .left + (0.5 * HMenuTextBuffer), .Top + (0.5 * VMenuTextBuffer), .Caption, .Enabled, Color
                End If
                If .Seperator Then
                    DrawControl 0, .Bottom - 3
                End If
            End With
        Next
    End If
    
End Sub

Private Function PinPointMouse(x As Long, y As Long) As Long
    Dim lpRect As RECT
    Dim CursorLeft As Long
    Dim CursorTop As Long
    Dim Count As Long
    
    GetWindowRect hwnd, lpRect
    CursorLeft = x - lpRect.left
    CursorTop = y - lpRect.Top
    
    PinPointMouse = -1
    
    For Count = LBound(MenuItems) To UBound(MenuItems)
        With MenuItems(Count)
            'If CursorTop > .Top - (VMenuTextBuffer / 2) And CursorTop < .Bottom - (VMenuTextBuffer / 2) Then
            If CursorTop > .Top - (VMenuTextBuffer / 2) And CursorTop < .Bottom Then
                PinPointMouse = Count
                Exit For
            End If
        End With
    Next
End Function

Private Sub DrawLine(WhatColor&, Index As Long)
    With MenuItems(Index)
        If Not .Seperator Then
            UserControl.Line (.left - 3, .Top + 1)-(.Right + HMenuTextBuffer + 2, .Bottom), WhatColor&, BF
        Else
            UserControl.Line (.left - 3, .Top + 2)-(.Right + HMenuTextBuffer + 2, .Bottom - 3), WhatColor&, BF
        End If
    End With
End Sub

Private Function DrawText(DrawOnDC As Long, x As Long, y As Long, hStr As String, tEnabled As Boolean, Clr As Long) As Long

    Dim OT As Long
    
    If DrawOnDC = 0 Then Exit Function
    OT = GetTextColor(DrawOnDC)
    SetTextColor DrawOnDC, Clr
    If tEnabled = False Then
        DrawText = DrawStateText(DrawOnDC, 0&, 0&, hStr, Len(hStr), x, y - 1.5, 0&, 0&, DST_PREFIXTEXT Or IIf(tEnabled = True, DSS_NORMAL, _
            DSS_DISABLED))
    Else
        DrawText = DrawStateText(DrawOnDC, 0&, 0&, hStr, Len(hStr), x, y, 0&, 0&, DST_PREFIXTEXT Or IIf(tEnabled = True, DSS_NORMAL, _
            DSS_DISABLED))
    End If
    SetTextColor DrawOnDC, OT
End Function

Private Sub DrawControl(x As Long, y As Long, Optional vntEdge)
    Dim R As RECT
    Dim intOffset%
    vntEdge = IIf(IsMissing(vntEdge), EDGE_RAISED, vntEdge)
    With UserControl
        R.left = -2
        R.Top = y + 2
        R.Right = ScaleX(Extender.Width, vbTwips, vbPixels) + 2
        R.Bottom = y + 4
        If vntEdge = EDGE_SUNKEN Then intOffset = 2
    End With
    DrawEdge hdc, R, CLng(vntEdge), BF_RECT
End Sub

Public Sub SynchColorsNow(Optional BC As Long = vbButtonFace, Optional HC As Long = vbHighlight, Optional FC As Long = vbMenuText, _
    Optional HFC As Long = vbHighlightText)
  
    BackColor = BC
    HilightColor = HC
    Dim ctl As Variant
    
    For Each ctl In MenuItems
        With ctl
            .HilightTextColor = HFC
            .ForeColor = FC
        End With
    Next
    SolidBackground = m_ctlSubMenuParent.SolidBackground
    ReDrawMenu
    
End Sub

Private Sub DrawCustomBackground()
    Dim i As Single, Color As Long
    Dim w As Single, h As Single
    
    'left to right
    w = ScaleX(Width, vbTwips, vbPixels)
    h = ScaleX(Height, vbTwips, vbPixels)
    For i = 0 To w
        Color = MakeDarker(BackColor, Int((i / w) * 55))
        UserControl.Line (i, 0)-(i, h), Color
    Next i
        
    Dim R As RECT
    R.left = 0
    R.Right = w - 1
    R.Top = 0
    R.Bottom = h - 1

    DrawEdge hdc, R, EDGE_RAISED, BF_RECT
    
    'TopToBottom
    'w = ScaleX(Width, vbTwips, vbPixels)
    'h = ScaleX(Height, vbTwips, vbPixels)
    'For i = 0 To h
    '    color = MakeLighter(BackColor, Int((i / h) * 75))
    '    UserControl.Line (0, i)-(w, i), color
    'Next i
End Sub

Private Function MakeLighter(ColorIn As Long, i As Long) As Long
      Dim R As Byte, g As Byte, b As Byte
      Dim R1 As Integer, B1 As Integer, G1 As Integer

   R = (ColorIn And 255) And 255
   g = (ColorIn \ 256) And 255
   b = (ColorIn \ 65536) And 255

   R1 = R + (i * 3)
   G1 = g + (i * 3)
   B1 = b + (i * 3)

   If R1 > 255 Then R1 = 255
   If G1 > 255 Then G1 = 255
   If B1 > 255 Then B1 = 255

   MakeLighter = RGB(R1, G1, B1)

End Function

Private Function MakeDarker(ColorIn As Long, i As Long) As Long
      Dim R As Byte, g As Byte, b As Byte
      Dim R1 As Integer, B1 As Integer, G1 As Integer

   R = (ColorIn And 255) And 255
   g = (ColorIn \ 256) And 255
   b = (ColorIn \ 65536) And 255

   R1 = R - (i * 3)
   G1 = g - (i * 3)
   B1 = b - (i * 3)

   If R1 < 0 Then R1 = 0
   If G1 < 0 Then G1 = 0
   If B1 < 0 Then B1 = 0

   MakeDarker = RGB(R1, G1, B1)

End Function

Public Sub ReSetProps()
    
    Dim mi As MenuItem, Count&
    
    For Count = LBound(MenuItems) To UBound(MenuItems)
        Set mi = MenuItems(Count)
        With mi
            If .Visible = False Then
                .Top = DetermineTop(Count)
                .Bottom = .Top
                .Height = 0
                .Width = MaxMenuTextWidth + HMenuTextBuffer
                .Right = .left + .Width
            Else
                .Top = DetermineTop(Count)
                .Bottom = .Top + TextHeight(.Caption)
                If .Seperator Then
                    .Bottom = .Bottom + mSepHeight
                End If
                .Height = .Bottom - .Top
                .Width = MaxMenuTextWidth
                .Right = .left + .Width
            End If
        End With
    Next
    Cls
    ReDrawMenu
    
End Sub

Private Function DetermineTop(Index As Long)
    Select Case True
        Case Index = 0
            DetermineTop = (VMenuTextBuffer / 2) - 1
        Case Else
            DetermineTop = MenuItems(Index - 1).Bottom + 1
    End Select
End Function

Public Sub CloseThisMenu()
    Cls
    m_lCurrentMenuItem = -1
    SubMenuParent.ChildShowing = False
    ReDrawMenu
    Extender.Visible = False
End Sub


Private Function MaxMenuTextWidth() As Long
    
    Dim Count&, TempMax&
    TempMax = -1
    For Count = LBound(MenuItems) To UBound(MenuItems)
        If TextWidth(MenuItems(Count).Caption) > TempMax Then
            TempMax = TextWidth(MenuItems(Count).Caption)
        End If
    Next
    MaxMenuTextWidth = TempMax

End Function

Private Sub m_ctlSubMenuParent_ParentClosing()
    Set m_ctlSubMenuParent = Nothing
End Sub

Private Sub m_ctlSubMenuParent_SubItemClicked(Parent As Long, SubIndex As Long)
    CloseThisMenu
End Sub

Private Sub m_ctlSubMenuParent_SubItemHover(Parent As Long, SubIndex As Long)

    If MenuItems(0).ParentIndex = Parent Then
        Extender.Visible = True
    Else
        CloseThisMenu
    End If
End Sub

Private Sub m_ctlSubMenuParent_SynchColors(BC As Long, HC As Long, FC As Long, HFC As Long)
    SynchColorsNow BC, HC, FC, HFC
End Sub

Private Sub UserControl_Initialize()
    ReDim MenuItems(-1 To -1) As MenuItem
    ScaleMode = vbPixels
    AutoRedraw = True
    DrawText hdc, 0, 0, "SubChild", True, vbBlack
OutSpot:
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim Index As Long
    
    Dim X1 As Long, Y1 As Long
    GetCursorPos pPoint
    X1 = pPoint.x
    Y1 = pPoint.y
    Index = PinPointMouse(X1, Y1)
    
    If Index <> -1 Then
        If MenuItems(Index).Enabled Then
            RaiseEvent SubItemChildClicked(MenuItems(0).ParentIndex, Index)
            'On Error Resume Next
            'Extender.Visible = False
            'SubMenuParent.ChildShowing = False
            CloseThisMenu
            SubMenuParent.CloseThisMenu
        End If
    End If

End Sub

Private Sub UserControl_Terminate()
    
    Dim mi As Variant
    For Each mi In MenuItems
        Set mi = Nothing
    Next
    Erase MenuItems
    Set m_ctlSubMenuParent = Nothing
    
End Sub

Private Sub TrackMouse_MouseOut()
    CloseThisMenu
    SubMenuParent.CheckMousePosition
End Sub

Private Sub TrackMouse_MouseOver(ByVal x As Long, ByVal y As Long)
    Dim Index As Long
    
    Index = PinPointMouse(x, y)
    If Index > -1 Then
        If CurrentMenuItem <> Index Then
            'hack
            CurrentMenuItem = CurrentMenuItem
            '/hack
            ReDrawMenu Index, True
            CurrentMenuItem = Index
        End If
    Else
        'Cls
        'CurrentMenuItem = -1
        'SubMenuParent.ChildShowing = False
        'ReDrawMenu
        CloseThisMenu
    End If
  
End Sub

Public Property Let HilightColor(ByVal lHilightColor As Long)
    m_lHilightColor = lHilightColor
End Property

Public Property Get HilightColor() As Long
    HilightColor = m_lHilightColor
End Property

Public Property Let CurrentMenuItem(ByVal lCurrentMenuItem As Long)
    m_lCurrentMenuItem = lCurrentMenuItem
End Property

Public Property Get CurrentMenuItem() As Long
    CurrentMenuItem = m_lCurrentMenuItem
End Property

Private Property Let hwnd(ByVal lhWnd As Long)
    m_lhWnd = lhWnd
End Property

Public Property Get hwnd() As Long
    hwnd = UserControl.hwnd
End Property

Public Property Set SubMenuParent(ctlSubMenuParent As ctlSubMenu)
    Set m_ctlSubMenuParent = ctlSubMenuParent
    Set UserControl.Font = ctlSubMenuParent.Font
    Set TrackMouse = New clsTrackMouse
    Set TrackMouse.TrackObject = Me
    ctlSubMenuParent.HasChild = True
End Property

Public Property Get SubMenuParent() As ctlSubMenu
    
    If Not (m_ctlSubMenuParent Is Nothing) Then
        Set SubMenuParent = m_ctlSubMenuParent
    Else
        Err.Raise vbObjectError + ErrorEnum.mnuerror_MustSetParentFirst
    End If
    
End Property

Private Property Let SubMenuHeight(ByVal lMenuHeight As Long)
    m_lMenuHeight = lMenuHeight
    Extender.Height = ScaleY(lMenuHeight, vbPixels, vbTwips)
End Property

Public Property Get SubMenuHeight() As Long
    SubMenuHeight = m_lMenuHeight
End Property

Private Property Let SubMenuWidth(ByVal lMenuWidth As Long)
    m_lMenuWidth = lMenuWidth
    Extender.Width = ScaleX(lMenuWidth, vbPixels, vbTwips)
End Property

Public Property Get SubMenuWidth() As Long
    SubMenuWidth = m_lMenuWidth
End Property

Public Property Get SolidBackground() As Boolean
    SolidBackground = m_bSolidBackground
End Property
Public Property Let SolidBackground(ByVal bSolidBackground As Boolean)
    m_bSolidBackground = bSolidBackground
End Property
